﻿
Namespace Model.Development
    Public Class DEV_WorkLog
        Public Sub New()

        End Sub

        Private _WorkLogID As Integer
        Public Property WorkLogID() As Integer
            Get
                Return _WorkLogID
            End Get
            Set(ByVal value As Integer)
                _WorkLogID = value
            End Set
        End Property

        Private _TaskID As Integer
        Public Property TaskID() As Integer
            Get
                Return _TaskID
            End Get
            Set(ByVal value As Integer)
                _TaskID = value
            End Set
        End Property

        Private _TaskName As String
        Public Property TaskName() As String
            Get
                Return _TaskName
            End Get
            Set(ByVal value As String)
                _TaskName = value
            End Set
        End Property

        Private _CreationDate As DateTime
        Public Property CreationDate() As DateTime
            Get
                Return _CreationDate
            End Get
            Set(ByVal value As DateTime)
                _CreationDate = value
            End Set
        End Property

        Private _CreationByID As Integer
        Public Property CreationByID() As Integer
            Get
                Return _CreationByID
            End Get
            Set(ByVal value As Integer)
                _CreationByID = value
            End Set
        End Property

        Private _CreationBy As String
        Public Property CreationBy() As String
            Get
                Return _CreationBy
            End Get
            Set(ByVal value As String)
                _CreationBy = value
            End Set
        End Property

        Private _LastUpdateDate As DateTime
        Public Property LastUpdateDate() As DateTime
            Get
                Return _LastUpdateDate
            End Get
            Set(ByVal value As DateTime)
                _LastUpdateDate = value
            End Set
        End Property

        Private _LastUpdateByID As Integer
        Public Property LastUpdateByID() As Integer
            Get
                Return _LastUpdateByID
            End Get
            Set(ByVal value As Integer)
                _LastUpdateByID = value
            End Set
        End Property

        Private _LastUpdateBy As String
        Public Property LastUpdateBy() As String
            Get
                Return _LastUpdateBy
            End Get
            Set(ByVal value As String)
                _LastUpdateBy = value
            End Set
        End Property

        Private _WorkDate As DateTime
        Public Property WorkDate() As DateTime
            Get
                Return _WorkDate
            End Get
            Set(ByVal value As DateTime)
                _WorkDate = value
            End Set
        End Property

        Private _WorkByID As Integer
        Public Property WorkByID() As Integer
            Get
                Return _WorkByID
            End Get
            Set(ByVal value As Integer)
                _WorkByID = value
            End Set
        End Property

        Private _WorkBy As String
        Public Property WorkBy() As String
            Get
                Return _WorkBy
            End Get
            Set(ByVal value As String)
                _WorkBy = value
            End Set
        End Property

        Private _Description As String
        Public Property Description() As String
            Get
                Return _Description
            End Get
            Set(ByVal value As String)
                _Description = value
            End Set
        End Property

        Private _WorkMinutes As Integer
        Public Property WorkMinutes() As Integer
            Get
                Return _WorkMinutes
            End Get
            Set(ByVal value As Integer)
                _WorkMinutes = value
            End Set
        End Property

        Public ReadOnly Property WorkTimeSpan() As TimeSpan
            Get
                Return TimeSpan.FromMinutes(_WorkMinutes)
            End Get
        End Property

        Public ReadOnly Property WorkHoursMinutes() As String
            Get
                Return WorkTimeSpan.Hours.ToString & "u" & WorkTimeSpan.Minutes.ToString
            End Get
        End Property

        Public Function GetMyClone() As DEV_WorkLog
            Dim clone As New DEV_WorkLog
            With clone
                .CreationBy = Me.CreationBy
                .CreationByID = Me.CreationByID
                .CreationDate = Me.CreationDate
                .Description = Me.Description
                .LastUpdateBy = Me.LastUpdateBy
                .LastUpdateByID = Me.LastUpdateByID
                .LastUpdateDate = Me.LastUpdateDate
                .WorkBy = Me.WorkBy
                .WorkByID = Me.WorkByID
                .WorkDate = Me.WorkDate
                .WorkLogID = Me.WorkLogID
                .WorkMinutes = Me.WorkMinutes
                .TaskID = Me.TaskID
                .TaskName = Me.TaskName
            End With
            Return clone
        End Function

        Private _Task As DEV_Task
        Public Property Task() As DEV_Task
            Get
                Return _Task
            End Get
            Set(ByVal value As DEV_Task)
                _Task = value
            End Set
        End Property
        Public ReadOnly Property Task_Project() As String
            Get
                If Not Task Is Nothing Then
                    Return Task.Project
                Else
                    Return ""
                End If
            End Get
        End Property
        Public ReadOnly Property Task_PriorityID() As DEV_Priorities
            Get
                If Not Task Is Nothing Then
                    Return Task.PriorityID
                Else
                    Return DEV_Priorities.Low
                End If
            End Get
        End Property
        Public ReadOnly Property Task_AssignedTo() As String
            Get
                If Not Task Is Nothing Then
                    Return Task.AssignedTo
                Else
                    Return ""
                End If
            End Get
        End Property
        Public ReadOnly Property Task_DepartmentID() As Integer
            Get
                If Not Task Is Nothing Then
                    Return Task.DepartmentID
                Else
                    Return 0
                End If
            End Get
        End Property
        Public ReadOnly Property Task_StateID() As DEV_States
            Get
                If Not Task Is Nothing Then
                    Return Task.StateID
                Else
                    Return 0
                End If
            End Get
        End Property
        Public ReadOnly Property Task_PercentComplete() As Integer
            Get
                If Not Task Is Nothing Then
                    Return Task.PercentComplete
                Else
                    Return 0
                End If
            End Get
        End Property
        Public ReadOnly Property Task_WorkTotalFormat() As String
            Get
                If Not Task Is Nothing Then
                    Return Task.WorkTotalFormat
                Else
                    Return ""
                End If
            End Get
        End Property
        Public ReadOnly Property Task_ScheduleTotalFormat() As String
            Get
                If Not Task Is Nothing Then
                    Return Task.ScheduleTotalFormat
                Else
                    Return ""
                End If
            End Get
        End Property

        ' Volgende 3 properties worden gebruikt bij het maandoverzicht in project management,
        ' in combinatie met taakplannen (DEV_TaskSchedule): vandaar gelijke naamgeving van velden noodzakelijk
        Public ReadOnly Property ItemBy() As String
            Get
                Return WorkBy
            End Get
        End Property
        Public ReadOnly Property ItemDate() As DateTime
            Get
                Return WorkDate
            End Get
        End Property
        Public ReadOnly Property ItemTime() As String
            Get
                Return WorkHoursMinutes
            End Get
        End Property

    End Class
End Namespace